Sternberg Working Memory Task
----------------------------------------------------------------


This task is adapted from the memory tasks described by Sternberg (1969). In this task participants must report whether or not a given target was present in a previous set of items. The set of values varies in length and the target can occur at any position in the set (or not at all). If participants search their memory of the set in a 'serial' fashion then their average response time will increase with increasing set size. If memory can be searched in a 'parallel' fashion then RT will be independent of set size.

Analysing your data:
-----------------------
In the Excel file, in the data/folder after running the experiment, sort the data by set size. Take the RT (the column `resp.rt`) for all the rows with a given set size and calculate the mean. Compare these means for different set sizes. You could also break the data down by trials where the target was actually present or actually absent to investigate whether the search was 'self-terminating'.

References
-------------

STERNBERG, S. (1969). MEMORY-SCANNING: MENTAL PROCESSES REVEALED BY REACTION-TIME EXPERIMENTS. American Scientist, 57(4), 421–457. http://www.jstor.org/stable/27828738